diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/hashers/hasher.c strongswancont-5.8.4-svc/src/libstrongswan/crypto/hashers/hasher.c
--- strongswan-5.8.4/src/libstrongswan/crypto/hashers/hasher.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/hashers/hasher.c	2022-07-06 15:47:34.810984000 +0300
@@ -37,7 +37,9 @@
 	"HASH_SHA3_256",
 	"HASH_SHA3_384",
 	"HASH_SHA3_512");
-ENUM_END(hash_algorithm_names, HASH_SHA3_512);
+ENUM_NEXT(hash_algorithm_names, BELT_HASH, BELT_HASH, HASH_SHA3_512,
+	"BELT_HASH");
+ENUM_END(hash_algorithm_names, BELT_HASH);
 
 ENUM_BEGIN(hash_algorithm_short_names, HASH_SHA1, HASH_IDENTITY,
 	"sha1",
@@ -55,7 +57,9 @@
 	"sha3_256",
 	"sha3_384",
 	"sha3_512");
-ENUM_END(hash_algorithm_short_names, HASH_SHA3_512);
+ENUM_NEXT(hash_algorithm_short_names, BELT_HASH, BELT_HASH, HASH_SHA3_512,
+	"belt_hash");
+ENUM_END(hash_algorithm_short_names, BELT_HASH);
 
 ENUM_BEGIN(hash_algorithm_short_names_upper, HASH_SHA1, HASH_IDENTITY,
 	"SHA1",
@@ -73,7 +77,9 @@
 	"SHA3_256",
 	"SHA3_384",
 	"SHA3_512");
-ENUM_END(hash_algorithm_short_names_upper, HASH_SHA3_512);
+ENUM_NEXT(hash_algorithm_short_names_upper, BELT_HASH, BELT_HASH, HASH_SHA3_512,
+	"BELT_HASH");
+ENUM_END(hash_algorithm_short_names_upper, BELT_HASH);
 
 /*
  * Described in header
@@ -141,6 +147,8 @@
 		case OID_SHA512:
 		case OID_SHA512_WITH_RSA:
 			return HASH_SHA512;
+		case OID_BELT_HASH:
+			return BELT_HASH;
 		case OID_SHA3_224:
 		case OID_RSASSA_PKCS1V15_WITH_SHA3_224:
 			return HASH_SHA3_224;
@@ -180,12 +188,16 @@
 			return HASH_SHA384;
 		case PRF_HMAC_SHA2_512:
 			return HASH_SHA512;
+		case PRF_HMAC_HBELT:
+			return BELT_HASH;
 		case PRF_HMAC_TIGER:
 		case PRF_AES128_XCBC:
 		case PRF_AES128_CMAC:
 		case PRF_FIPS_DES:
 		case PRF_CAMELLIA128_XCBC:
 		case PRF_UNDEFINED:
+		case PRF_BRNG_CTR_HBELT:
+		case PRF_BRNG_HMAC_HBELT:
 			break;
 	}
 	return HASH_UNKNOWN;
@@ -227,6 +239,15 @@
 			case AUTH_HMAC_SHA2_512_512:
 				*length = 64;
 				break;
+			case AUTH_BELT_HASH_LEGACY:
+			case AUTH_GOST_MAC_LEGACY:
+			case AUTH_BELT_MAC_LEGACY:
+			case AUTH_BELT_HMAC_LEGACY:
+			case AUTH_BELT_HASH:
+			case AUTH_GOST_MAC:
+			case AUTH_BELT_MAC:
+			case AUTH_BELT_HMAC:
+				*length = 32;
 			default:
 				break;
 		}
@@ -251,6 +272,15 @@
 		case AUTH_HMAC_SHA2_512_256:
 		case AUTH_HMAC_SHA2_512_512:
 			return HASH_SHA512;
+		case AUTH_GOST_MAC_LEGACY:
+		case AUTH_BELT_MAC_LEGACY:
+		case AUTH_BELT_HMAC_LEGACY:
+		case AUTH_BELT_HASH_LEGACY:
+		case AUTH_GOST_MAC:
+		case AUTH_BELT_MAC:
+		case AUTH_BELT_HMAC:
+		case AUTH_BELT_HASH:
+			return BELT_HASH;		
 		case AUTH_AES_CMAC_96:
 		case AUTH_AES_128_GMAC:
 		case AUTH_AES_192_GMAC:
@@ -322,6 +352,8 @@
 					return AUTH_HMAC_SHA2_512_512;
 			}
 			break;
+		case BELT_HASH:
+			return AUTH_BELT_HASH;
 		case HASH_MD2:
 		case HASH_MD4:
 		case HASH_SHA224:
@@ -347,6 +379,7 @@
 		case HASH_SHA256:
 		case HASH_SHA384:
 		case HASH_SHA512:
+		case BELT_HASH:
 			return TRUE;
 		case HASH_UNKNOWN:
 		case HASH_MD2:
@@ -393,6 +426,9 @@
 		case HASH_SHA512:
 			oid = OID_SHA512;
 			break;
+		case BELT_HASH:
+			oid = OID_BELT_HASH;
+			break;
 		case HASH_SHA3_224:
 			oid = OID_SHA3_224;
 			break;
@@ -494,6 +530,15 @@
 				default:
 					return OID_UNKNOWN;
 			}
+		case KEY_BIGN:
+			switch (alg)
+			{
+				case BELT_HASH:
+					return OID_HASH_BELT;
+				case HASH_UNKNOWN:
+				default:
+					return OID_UNKNOWN;
+			}
 		default:
 			return OID_UNKNOWN;
 	}
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/hashers/hasher.h strongswancont-5.8.4-svc/src/libstrongswan/crypto/hashers/hasher.h
--- strongswan-5.8.4/src/libstrongswan/crypto/hashers/hasher.h	2018-10-23 20:03:28.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/hashers/hasher.h	2022-07-06 15:47:34.802984000 +0300
@@ -42,6 +42,8 @@
 	HASH_SHA512			= 4,
 	/* RFC 8420 */
 	HASH_IDENTITY		= 5,
+
+	BELT_HASH			= 9,
 	/* use private use range for algorithms not defined/permitted by RFC 7427 */
 	HASH_UNKNOWN 		= 1024,
 	HASH_MD2 			= 1025,
@@ -62,6 +64,7 @@
 #define HASH_SIZE_SHA256	32
 #define HASH_SIZE_SHA384	48
 #define HASH_SIZE_SHA512	64
+#define HASH_SIZE_BELT		32
 
 /**
  * enum names for hash_algorithm_t.
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/iv/iv_gen.c strongswancont-5.8.4-svc/src/libstrongswan/crypto/iv/iv_gen.c
--- strongswan-5.8.4/src/libstrongswan/crypto/iv/iv_gen.c	2019-11-28 23:30:39.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/iv/iv_gen.c	2022-07-06 15:47:34.802984000 +0300
@@ -40,6 +40,16 @@
 		case ENCR_SERPENT_CBC:
 		case ENCR_TWOFISH_CBC:
 		case ENCR_RC2_CBC:
+		case ENCR_GOST28147_CTR_LEGACY:
+		case ENCR_GOST28147_CFB_LEGACY:
+		case ENCR_BELT_CBC_LEGACY:
+		case ENCR_BELT_CFB_LEGACY:
+		case ENCR_BELT_CTR_LEGACY:
+		case ENCR_GOST28147_CTR:
+		case ENCR_GOST28147_CFB:
+		case ENCR_BELT_CBC:
+		case ENCR_BELT_CFB:
+		case ENCR_BELT_CTR:
 			return iv_gen_rand_create();
 		case ENCR_AES_CTR:
 		case ENCR_AES_CCM_ICV8:
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/key_transformer.c strongswancont-5.8.4-svc/src/libstrongswan/crypto/key_transformer.c
--- strongswan-5.8.4/src/libstrongswan/crypto/key_transformer.c	1970-01-01 03:00:00.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/key_transformer.c	2022-07-06 15:47:34.838984000 +0300
@@ -0,0 +1,6 @@
+#include "key_transformer.h"
+
+ENUM(key_transform_algorithm_names, KEYTFM_UNDEFINED, BELT_KEYREP_TRANSFORM,
+	"KEY_TRANSFORM_UNDEFINED",
+	"BELT_KEYREP_TRANSFORM",
+);
\ В конце файла нет новой строки
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/key_transformer.h strongswancont-5.8.4-svc/src/libstrongswan/crypto/key_transformer.h
--- strongswan-5.8.4/src/libstrongswan/crypto/key_transformer.h	1970-01-01 03:00:00.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/key_transformer.h	2022-07-06 15:47:34.830984000 +0300
@@ -0,0 +1,55 @@
+/**
+ * @defgroup key_transformer key_transformer
+ * @{ @ingroup crypto
+ */
+
+#ifndef KEY_TRANSFORMER_H_
+#define KEY_TRANSFORMER_H_
+
+typedef enum key_transform_alorithm_t key_transform_alorithm_t;
+typedef enum key_transform_args_t key_transform_args_t;
+typedef struct key_transformer_t key_transformer_t;
+
+#include <library.h>
+
+/**
+ *	Key transform algorithm
+ */
+enum key_transform_alorithm_t {
+
+	KEYTFM_UNDEFINED = 0,
+	
+	/** KeyRep algorithm from STB 34.101.31 */
+	BELT_KEYREP_TRANSFORM = 1,
+};
+
+/**
+ * enum strings for key_transform_alorithm_t.
+ */
+extern enum_name_t *key_transform_algorithm_names;
+
+/**
+ * Key transform interface.
+ */
+struct key_transformer_t {
+
+	/**
+	 * Transform key of proveded level into another key 
+	 * of level + 1 associated with proveded header.
+	 *
+	 * @param in 			a key to transform
+	 * @param out 			transformed key
+	 * @param in_level		level of the input key
+	 * @param out_header	header associated with produced key
+	 * @return				TRUE on successful transformation, FALSE otherwise
+	 */
+	bool (*transform)(key_transformer_t *this, chunk_t in, chunk_t out, 
+									chunk_t in_level, chunk_t out_header);
+
+	/**
+	 * Destructor.
+	 */
+	void (*destroy)(key_transformer_t *this);
+};
+
+#endif /** KEY_TRANSFORMER_H_ @}*/
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/prfs/prf.c strongswancont-5.8.4-svc/src/libstrongswan/crypto/prfs/prf.c
--- strongswan-5.8.4/src/libstrongswan/crypto/prfs/prf.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/prfs/prf.c	2022-07-06 15:47:34.806984000 +0300
@@ -25,7 +25,7 @@
 	"PRF_FIPS_DES",
 	"PRF_KEYED_SHA1",
 	"PRF_CAMELLIA128_XCBC");
-ENUM_NEXT(pseudo_random_function_names, PRF_HMAC_MD5, PRF_AES128_CMAC, PRF_CAMELLIA128_XCBC,
+ENUM_NEXT(pseudo_random_function_names, PRF_HMAC_MD5, PRF_BRNG_HMAC_HBELT, PRF_CAMELLIA128_XCBC,
 	"PRF_HMAC_MD5",
 	"PRF_HMAC_SHA1",
 	"PRF_HMAC_TIGER",
@@ -33,8 +33,12 @@
 	"PRF_HMAC_SHA2_256",
 	"PRF_HMAC_SHA2_384",
 	"PRF_HMAC_SHA2_512",
-	"PRF_AES128_CMAC");
-ENUM_END(pseudo_random_function_names, PRF_AES128_CMAC);
+	"PRF_AES128_CMAC",
+	"PRF_BRNG_CTR_HBELT",
+	"PRF_BRNG_HMAC_HBELT");
+ENUM_NEXT(pseudo_random_function_names, PRF_HMAC_HBELT, PRF_HMAC_HBELT, PRF_BRNG_HMAC_HBELT,
+	"PRF_HMAC_HBELT");
+ENUM_END(pseudo_random_function_names, PRF_HMAC_HBELT);
 
 /*
  * Described in header.
@@ -51,6 +55,10 @@
 			return PRF_HMAC_SHA2_384;
 		case OID_HMAC_SHA512:
 			return PRF_HMAC_SHA2_512;
+		case OID_BRNG_CTR_HBELT:
+			return PRF_BRNG_CTR_HBELT;
+		case OID_BRNG_HMAC_HBELT:
+			return PRF_BRNG_HMAC_HBELT;
 		case OID_HMAC_SHA224:
 		case OID_HMAC_SHA512_224:
 		case OID_HMAC_SHA512_256:
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/prfs/prf.h strongswancont-5.8.4-svc/src/libstrongswan/crypto/prfs/prf.h
--- strongswan-5.8.4/src/libstrongswan/crypto/prfs/prf.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/prfs/prf.h	2022-07-06 15:47:34.838984000 +0300
@@ -52,6 +52,10 @@
 	PRF_HMAC_SHA2_512 = 7,
 	/** RFC4615 */
 	PRF_AES128_CMAC = 8,
+	/** PRFBRNG_CTR */
+	PRF_BRNG_CTR_HBELT = 9,
+	/** PRFBRNG_HMAC */
+	PRF_BRNG_HMAC_HBELT = 10,
 	/** FIPS 186-2-change1 */
 	PRF_FIPS_SHA1_160 = 1025,
 	/** FIPS 186-2-change1, uses fixed output size of 160bit */
@@ -62,6 +66,8 @@
 	PRF_KEYED_SHA1 = 1027,
 	/** draft-kanno-ipsecme-camellia-xcbc, not yet assigned by IANA */
 	PRF_CAMELLIA128_XCBC = 1028,
+	/** STB 34.101.47, 6.1 */
+	PRF_HMAC_HBELT = 65530,
 };
 
 /**
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/proposal/proposal.c strongswancont-5.8.4-svc/src/libstrongswan/crypto/proposal/proposal.c
--- strongswan-5.8.4/src/libstrongswan/crypto/proposal/proposal.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/proposal/proposal.c	2022-07-06 15:47:34.838984000 +0300
@@ -26,6 +26,7 @@
 #include <crypto/prfs/prf.h>
 #include <crypto/crypters/crypter.h>
 #include <crypto/signers/signer.h>
+#include <crypto/key_transformer.h>
 
 ENUM(protocol_id_names, PROTO_NONE, PROTO_IPCOMP,
 	"PROTO_NONE",
@@ -633,6 +634,8 @@
 	{AUTH_AES_XCBC_96,					PRF_AES128_XCBC					},
 	{AUTH_CAMELLIA_XCBC_96,				PRF_CAMELLIA128_XCBC			},
 	{AUTH_AES_CMAC_96,					PRF_AES128_CMAC					},
+	{AUTH_BELT_HASH_LEGACY,				PRF_BRNG_CTR_HBELT				},
+	{AUTH_BELT_HASH,					PRF_HMAC_HBELT					},
 };
 
 /**
@@ -983,6 +986,7 @@
 	integrity_algorithm_t integrity;
 	pseudo_random_function_t prf;
 	diffie_hellman_group_t group;
+	key_transform_alorithm_t tfmer;
 	const char *plugin_name;
 
 	if (aead)
@@ -1040,19 +1044,20 @@
 	}
 	else
 	{
-		/* Round 1 adds algorithms with at least 128 bit security strength */
+		/* first round, appending BY algos */
 		enumerator = lib->crypto->create_crypter_enumerator(lib->crypto);
 		while (enumerator->enumerate(enumerator, &encryption, &plugin_name))
 		{
 			switch (encryption)
 			{
-				case ENCR_AES_CBC:
-				case ENCR_AES_CTR:
-				case ENCR_CAMELLIA_CBC:
-				case ENCR_CAMELLIA_CTR:
-					/* we assume that we support all AES/Camellia sizes */
-					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, 128);
-					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, 192);
+				case ENCR_BELT_CBC:
+				case ENCR_BELT_CFB:
+				case ENCR_BELT_CTR:
+					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, /*256*/ 0);
+					break;
+				case ENCR_BELT_CBC_LEGACY:
+				case ENCR_BELT_CFB_LEGACY:
+				case ENCR_BELT_CTR_LEGACY:
 					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, 256);
 					break;
 				default:
@@ -1061,18 +1066,35 @@
 		}
 		enumerator->destroy(enumerator);
 
-		/* Round 2 adds algorithms with less than 128 bit security strength */
+		/* second round, appending others */
 		enumerator = lib->crypto->create_crypter_enumerator(lib->crypto);
 		while (enumerator->enumerate(enumerator, &encryption, &plugin_name))
 		{
 			switch (encryption)
 			{
+				case ENCR_AES_CBC:
+				case ENCR_AES_CTR:
+				case ENCR_CAMELLIA_CBC:
+				case ENCR_CAMELLIA_CTR:
+					/* we assume that we support all AES/Camellia sizes */
+					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, 128);
+					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, 192);
+					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, 256);
+					break;
 				case ENCR_3DES:
 					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, 0);
 					break;
 				case ENCR_DES:
 					/* no, thanks */
 					break;
+				case ENCR_GOST28147_CFB:
+				case ENCR_GOST28147_CTR:
+					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, /*256*/ 0);
+					break;
+				case ENCR_GOST28147_CFB_LEGACY:
+				case ENCR_GOST28147_CTR_LEGACY:
+					add_algorithm(this, ENCRYPTION_ALGORITHM, encryption, 256);
+					break;
 				default:
 					break;
 			}
@@ -1084,15 +1106,16 @@
 			return FALSE;
 		}
 
-		/* Round 1 adds algorithms with at least 128 bit security strength */
+		/* first round, appending BY algos */
 		enumerator = lib->crypto->create_signer_enumerator(lib->crypto);
 		while (enumerator->enumerate(enumerator, &integrity, &plugin_name))
 		{
 			switch (integrity)
 			{
-				case AUTH_HMAC_SHA2_256_128:
-				case AUTH_HMAC_SHA2_384_192:
-				case AUTH_HMAC_SHA2_512_256:
+				case AUTH_BELT_HMAC_LEGACY:
+				case AUTH_BELT_MAC_LEGACY:
+				case AUTH_BELT_HMAC:
+				case AUTH_BELT_MAC:
 					add_algorithm(this, INTEGRITY_ALGORITHM, integrity, 0);
 					break;
 				default:
@@ -1101,12 +1124,15 @@
 		}
 		enumerator->destroy(enumerator);
 
-		/* Round 2 adds algorithms with less than 128 bit security strength */
+		/* second round, appending others */
 		enumerator = lib->crypto->create_signer_enumerator(lib->crypto);
 		while (enumerator->enumerate(enumerator, &integrity, &plugin_name))
 		{
 			switch (integrity)
 			{
+				case AUTH_HMAC_SHA2_256_128:
+				case AUTH_HMAC_SHA2_384_192:
+				case AUTH_HMAC_SHA2_512_256:
 				case AUTH_AES_XCBC_96:
 				case AUTH_AES_CMAC_96:
 				case AUTH_HMAC_SHA1_96:
@@ -1114,6 +1140,11 @@
 					break;
 				case AUTH_HMAC_MD5_96:
 					/* no, thanks */
+					break;
+				case AUTH_GOST_MAC_LEGACY:
+				case AUTH_GOST_MAC:
+					add_algorithm(this, INTEGRITY_ALGORITHM, integrity, 0);
+					break;
 				default:
 					break;
 			}
@@ -1132,6 +1163,9 @@
 			case PRF_HMAC_SHA2_512:
 			case PRF_AES128_XCBC:
 			case PRF_AES128_CMAC:
+			case PRF_BRNG_CTR_HBELT:
+			case PRF_BRNG_HMAC_HBELT:
+			case PRF_HMAC_HBELT:
 				add_algorithm(this, PSEUDO_RANDOM_FUNCTION, prf, 0);
 				break;
 			default:
@@ -1170,6 +1204,7 @@
 			case ECP_256_BP:
 			case ECP_384_BP:
 			case ECP_512_BP:
+			case ECP_256_BIGN:
 			case CURVE_25519:
 			case CURVE_448:
 			case NTRU_128_BIT:
@@ -1236,6 +1271,20 @@
 	}
 	enumerator->destroy(enumerator);
 
+	enumerator = lib->crypto->create_key_transformer_enumerator(lib->crypto);
+	while (enumerator->enumerate(enumerator, &tfmer, &plugin_name))
+	{
+		switch (tfmer)
+		{
+			case BELT_KEYREP_TRANSFORM:
+				add_algorithm(this, KEY_TRANSFORM_ALGORITHM, tfmer, 0);
+				break;
+			default:
+				break;
+		}
+	}
+	enumerator->destroy(enumerator);
+
 	return TRUE;
 }
 
@@ -1249,24 +1298,30 @@
 	switch (protocol)
 	{
 		case PROTO_IKE:
+			add_algorithm(this, ENCRYPTION_ALGORITHM,   ENCR_BELT_CFB,        0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,    AUTH_BELT_HMAC,       0);
+			add_algorithm(this, PSEUDO_RANDOM_FUNCTION, PRF_BRNG_HMAC_HBELT,  0);
+			add_algorithm(this, DIFFIE_HELLMAN_GROUP,   ECP_256_BIGN,         0);
+			/*
 			if (!proposal_add_supported_ike(this, FALSE))
 			{
 				destroy(this);
 				return NULL;
-			}
+			}*/
 			break;
 		case PROTO_ESP:
-			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_AES_CBC,          128);
-			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_AES_CBC,          192);
-			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_AES_CBC,          256);
-			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_HMAC_SHA2_256_128,  0);
-			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_HMAC_SHA2_384_192,  0);
-			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_HMAC_SHA2_512_256,  0);
-			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_HMAC_SHA1_96,       0);
-			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_AES_XCBC_96,        0);
-			add_algorithm(this, EXTENDED_SEQUENCE_NUMBERS, NO_EXT_SEQ_NUMBERS, 0);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_BELT_CFB,           0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_MAC,           0);
 			break;
 		case PROTO_AH:
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_MAC_LEGACY,    0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_HMAC_LEGACY,   0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_GOST_MAC_LEGACY,    0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_HASH_LEGACY,   0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_MAC,           0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_HMAC,          0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_GOST_MAC,           0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_HASH,          0);
 			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_HMAC_SHA2_256_128,  0);
 			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_HMAC_SHA2_384_192,  0);
 			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_HMAC_SHA2_512_256,  0);
@@ -1290,6 +1345,7 @@
 	switch (protocol)
 	{
 		case PROTO_IKE:
+			/*
 			this = (private_proposal_t*)proposal_create(protocol, 0);
 			if (!proposal_add_supported_ike(this, TRUE))
 			{
@@ -1297,10 +1353,48 @@
 				return NULL;
 			}
 			return &this->public;
+			*/
+			this = (private_proposal_t*)proposal_create(protocol, 0);
+			if (!proposal_add_supported_ike(this, FALSE))
+			{
+				destroy(this);
+				return NULL;
+			}
+			return &this->public;
 		case PROTO_ESP:
 			/* we currently don't include any AEAD proposal for ESP, as we
 			 * don't know if our kernel backend actually supports it. */
-			return NULL;
+			this = (private_proposal_t*)proposal_create(protocol, 0);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_BELT_CFB,                 0);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_BELT_CBC,                 0);			
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_BELT_CTR,                 0);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_BELT_CBC_LEGACY,        256);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_BELT_CFB_LEGACY,        256);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_BELT_CTR_LEGACY,        256);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_GOST28147_CFB_LEGACY,   256);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_GOST28147_CTR_LEGACY,   256);			
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_GOST28147_CFB,            0);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_GOST28147_CTR,            0);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_AES_CBC,          128);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_AES_CBC,          192);
+			add_algorithm(this, ENCRYPTION_ALGORITHM, ENCR_AES_CBC,          256);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_MAC,           0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_HMAC,          0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_HASH,          0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_MAC_LEGACY,    0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_HMAC_LEGACY,   0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_GOST_MAC_LEGACY,    0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_BELT_HASH_LEGACY,   0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_GOST_MAC,           0);			
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_HMAC_SHA2_256_128,  0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_HMAC_SHA2_384_192,  0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_HMAC_SHA2_512_256,  0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_HMAC_SHA1_96,       0);
+			add_algorithm(this, INTEGRITY_ALGORITHM,  AUTH_AES_XCBC_96,        0);			
+			add_algorithm(this, EXTENDED_SEQUENCE_NUMBERS, NO_EXT_SEQ_NUMBERS, 0);
+			return &this->public;
+			//return NULL;
+
 		case PROTO_AH:
 		default:
 			return NULL;
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/signers/signer.c strongswancont-5.8.4-svc/src/libstrongswan/crypto/signers/signer.c
--- strongswan-5.8.4/src/libstrongswan/crypto/signers/signer.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/signers/signer.c	2022-07-06 15:47:34.806984000 +0300
@@ -24,7 +24,7 @@
 	"HMAC_SHA2_384_384",
 	"HMAC_SHA2_512_512",
 	"CAMELLIA_XCBC_96");
-ENUM_NEXT(integrity_algorithm_names, AUTH_HMAC_MD5_96, AUTH_HMAC_SHA2_512_256, AUTH_CAMELLIA_XCBC_96,
+ENUM_NEXT(integrity_algorithm_names, AUTH_HMAC_MD5_96, AUTH_BELT_HASH_LEGACY, AUTH_CAMELLIA_XCBC_96,
 	"HMAC_MD5_96",
 	"HMAC_SHA1_96",
 	"DES_MAC",
@@ -38,6 +38,15 @@
 	"AES_256_GMAC",
 	"HMAC_SHA2_256_128",
 	"HMAC_SHA2_384_192",
-	"HMAC_SHA2_512_256");
-ENUM_END(integrity_algorithm_names, AUTH_HMAC_SHA2_512_256);
+	"HMAC_SHA2_512_256",
+	"GOST_MAC_LEGACY",
+	"BELT_MAC_LEGACY",
+	"BELT_HMAC_LEGACY",
+	"BELT_HASH_LEGACY");
+ENUM_NEXT(integrity_algorithm_names, AUTH_GOST_MAC, AUTH_BELT_HASH, AUTH_BELT_HASH_LEGACY,
+	"GOST_MAC",
+	"BELT_MAC",
+	"BELT_HMAC",
+	"BELT_HASH");
+ENUM_END(integrity_algorithm_names, AUTH_BELT_HASH);
 
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/signers/signer.h strongswancont-5.8.4-svc/src/libstrongswan/crypto/signers/signer.h
--- strongswan-5.8.4/src/libstrongswan/crypto/signers/signer.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/signers/signer.h	2022-07-06 15:47:34.842984000 +0300
@@ -63,6 +63,12 @@
 	AUTH_HMAC_SHA2_384_192 = 13,
 	/** RFC4868 */
 	AUTH_HMAC_SHA2_512_256 = 14,
+	/** GOST28147 */
+	AUTH_GOST_MAC_LEGACY = 15,
+	/** STB 34.101.31 */
+	AUTH_BELT_MAC_LEGACY = 16,
+	AUTH_BELT_HMAC_LEGACY = 17,
+	AUTH_BELT_HASH_LEGACY = 18,
 	/** private use */
 	AUTH_HMAC_SHA1_128 = 1025,
 	/** SHA256 96 bit truncation variant, supported by Linux kernels */
@@ -75,6 +81,12 @@
 	AUTH_HMAC_SHA2_512_512 = 1029,
 	/** draft-kanno-ipsecme-camellia-xcbc, not yet assigned by IANA */
 	AUTH_CAMELLIA_XCBC_96 = 1030,
+
+	/* private BY space */
+	AUTH_GOST_MAC = 65529,
+	AUTH_BELT_MAC = 65530,
+	AUTH_BELT_HMAC = 65531,
+	AUTH_BELT_HASH = 65532,
 };
 
 /**
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/transform.c strongswancont-5.8.4-svc/src/libstrongswan/crypto/transform.c
--- strongswan-5.8.4/src/libstrongswan/crypto/transform.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/transform.c	2022-07-06 15:47:34.842984000 +0300
@@ -17,14 +17,15 @@
 #include <crypto/hashers/hasher.h>
 #include <crypto/rngs/rng.h>
 
-ENUM_BEGIN(transform_type_names, ENCRYPTION_ALGORITHM, EXTENDED_SEQUENCE_NUMBERS,
+ENUM_BEGIN(transform_type_names, ENCRYPTION_ALGORITHM, KEY_TRANSFORM_ALGORITHM,
 	"ENCRYPTION_ALGORITHM",
 	"PSEUDO_RANDOM_FUNCTION",
 	"INTEGRITY_ALGORITHM",
 	"DIFFIE_HELLMAN_GROUP",
-	"EXTENDED_SEQUENCE_NUMBERS");
+	"EXTENDED_SEQUENCE_NUMBERS",
+	"KEY_TRANSFORM_ALGORITHM");
 ENUM_NEXT(transform_type_names, HASH_ALGORITHM, DETERMINISTIC_RANDOM_BIT_GENERATOR,
-		  EXTENDED_SEQUENCE_NUMBERS,
+		  KEY_TRANSFORM_ALGORITHM,
 	"HASH_ALGORITHM",
 	"RANDOM_NUMBER_GENERATOR",
 	"AEAD_ALGORITHM",
@@ -65,6 +66,8 @@
 			return ext_out_function_names;
 		case DETERMINISTIC_RANDOM_BIT_GENERATOR:
 			return drbg_type_names;
+		case KEY_TRANSFORM_ALGORITHM:
+			return key_transform_algorithm_names;
 		case COMPRESSION_ALGORITHM:
 			break;
 	}
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/transform.h strongswancont-5.8.4-svc/src/libstrongswan/crypto/transform.h
--- strongswan-5.8.4/src/libstrongswan/crypto/transform.h	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/transform.h	2022-07-06 15:47:34.830984000 +0300
@@ -34,6 +34,7 @@
 	INTEGRITY_ALGORITHM = 3,
 	DIFFIE_HELLMAN_GROUP = 4,
 	EXTENDED_SEQUENCE_NUMBERS = 5,
+	KEY_TRANSFORM_ALGORITHM = 6,
 	HASH_ALGORITHM = 256,
 	RANDOM_NUMBER_GENERATOR = 257,
 	AEAD_ALGORITHM = 258,
diff -ruN strongswan-5.8.4/src/libstrongswan/eap/eap.c strongswancont-5.8.4-svc/src/libstrongswan/eap/eap.c
--- strongswan-5.8.4/src/libstrongswan/eap/eap.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/eap/eap.c	2022-07-06 15:47:34.834984000 +0300
@@ -59,7 +59,9 @@
 	"EAP_TNC");
 ENUM_NEXT(eap_type_names, EAP_PT_EAP, EAP_PT_EAP, EAP_TNC,
 	"EAP_PT_EAP");
-ENUM_NEXT(eap_type_names, EAP_EXPANDED, EAP_DYNAMIC, EAP_PT_EAP,
+ENUM_NEXT(eap_type_names, EAP_BPACE, EAP_DYNAMIC, EAP_PT_EAP,
+	"EAP_BPACE",
+	"EAP_BSTS",
 	"EAP_EXPANDED",
 	"EAP_EXPERIMENTAL",
 	"EAP_RADIUS",
@@ -90,7 +92,9 @@
 	"TNC");
 ENUM_NEXT(eap_type_short_names, EAP_PT_EAP, EAP_PT_EAP, EAP_TNC,
 	"PT");
-ENUM_NEXT(eap_type_short_names, EAP_EXPANDED, EAP_DYNAMIC, EAP_PT_EAP,
+ENUM_NEXT(eap_type_short_names, EAP_BPACE, EAP_DYNAMIC, EAP_PT_EAP,
+	"BPACE",
+	"BSTS",
 	"EXP",
 	"XP",
 	"RAD",
@@ -121,6 +125,8 @@
 		{"pt",			EAP_PT_EAP},
 		{"dynamic",		EAP_DYNAMIC},
 		{"radius",		EAP_RADIUS},
+		{"bpace", 		EAP_BPACE},
+		{"bsts",		EAP_BSTS},
 	};
 
 	for (i = 0; i < countof(types); i++)
diff -ruN strongswan-5.8.4/src/libstrongswan/eap/eap.h strongswancont-5.8.4-svc/src/libstrongswan/eap/eap.h
--- strongswan-5.8.4/src/libstrongswan/eap/eap.h	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/eap/eap.h	2022-07-06 15:47:34.850984000 +0300
@@ -68,6 +68,8 @@
 	EAP_MSTLV = 33,
 	EAP_TNC = 38,
 	EAP_PT_EAP = 54,
+	EAP_BPACE = 252,
+	EAP_BSTS = 253,
 	EAP_EXPANDED = 254,
 	EAP_EXPERIMENTAL = 255,
 	/** not a method, but an implementation providing different methods */
diff -ruN strongswan-5.8.4/src/libstrongswan/Makefile.am strongswancont-5.8.4-svc/src/libstrongswan/Makefile.am
--- strongswan-5.8.4/src/libstrongswan/Makefile.am	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/Makefile.am	2023-03-28 13:57:36.145408000 +0300
@@ -13,7 +13,7 @@
 crypto/rngs/rng.c crypto/rngs/rng_tester.c \
 crypto/prf_plus.c crypto/signers/signer.c \
 crypto/signers/mac_signer.c crypto/crypto_factory.c crypto/crypto_tester.c \
-crypto/diffie_hellman.c crypto/aead.c crypto/transform.c \
+crypto/diffie_hellman.c crypto/aead.c crypto/key_transformer.c crypto/transform.c \
 crypto/iv/iv_gen.c crypto/iv/iv_gen_rand.c crypto/iv/iv_gen_seq.c \
 crypto/iv/iv_gen_null.c \
 crypto/xofs/xof.c crypto/xofs/xof_bitspender.c \
@@ -32,9 +32,10 @@
 database/database_factory.c fetcher/fetcher.c fetcher/fetcher_manager.c eap/eap.c \
 ipsec/ipsec_types.c \
 networking/host.c networking/host_resolver.c networking/packet.c \
-networking/tun_device.c networking/streams/stream_manager.c \
+networking/streams/stream_manager.c \
 networking/streams/stream.c networking/streams/stream_service.c \
 networking/streams/stream_tcp.c networking/streams/stream_service_tcp.c \
+networking/streams/stream_unix.c networking/streams/stream_service_unix.c \
 pen/pen.c plugins/plugin_loader.c plugins/plugin_feature.c processing/jobs/job.c \
 processing/jobs/callback_job.c processing/processor.c processing/scheduler.c \
 processing/watcher.c resolver/resolver_manager.c resolver/rr_set.c \
@@ -55,8 +56,21 @@
     threading/rwlock.c \
     threading/spinlock.c \
     threading/semaphore.c \
-    networking/streams/stream_unix.c \
-    networking/streams/stream_service_unix.c
+    networking/tun_device.c
+else
+  libstrongswan_la_SOURCES += \
+    threading/windows/thread.c \
+    threading/windows/thread_value.c \
+    threading/windows/mutex.c \
+    threading/windows/rwlock.c \
+    threading/windows/spinlock.c \
+    threading/windows/semaphore.c \
+    utils/compat/windows.c \
+    utils/windows_helper.c \
+    networking/windows_tun.c
+if USE_WINTUN
+  libstrongswan_la_SOURCES += networking/wintun_support.c
+endif
 endif
 
 # private header files
@@ -77,8 +91,8 @@
 crypto/prfs/prf.h crypto/prfs/mac_prf.h crypto/nonce_gen.h \
 crypto/prf_plus.h crypto/signers/signer.h crypto/signers/mac_signer.h \
 crypto/crypto_factory.h crypto/crypto_tester.h crypto/diffie_hellman.h \
-crypto/aead.h crypto/transform.h crypto/pkcs5.h crypto/iv/iv_gen.h \
-crypto/iv/iv_gen_rand.h crypto/iv/iv_gen_seq.h crypto/iv/iv_gen_null.h \
+crypto/aead.h crypto/key_transformer.h crypto/transform.h crypto/pkcs5.h \
+crypto/iv/iv_gen.h crypto/iv/iv_gen_rand.h crypto/iv/iv_gen_seq.h crypto/iv/iv_gen_null.h \
 crypto/xofs/xof.h crypto/xofs/xof_bitspender.h crypto/xofs/mgf1.h \
 credentials/credential_factory.h credentials/builder.h \
 credentials/cred_encoding.h credentials/keys/private_key.h \
@@ -99,7 +113,7 @@
 database/database.h database/database_factory.h fetcher/fetcher.h \
 fetcher/fetcher_manager.h eap/eap.h pen/pen.h ipsec/ipsec_types.h \
 networking/host.h networking/host_resolver.h networking/packet.h \
-networking/tun_device.h networking/streams/stream.h \
+networking/streams/stream.h \
 networking/streams/stream_unix.h networking/streams/stream_service_unix.h \
 networking/streams/stream_service_systemd.h \
 networking/streams/stream_tcp.h networking/streams/stream_service_tcp.h \
@@ -122,6 +136,18 @@
 utils/utils/atomics.h utils/utils/types.h utils/utils/byteorder.h \
 utils/utils/string.h utils/utils/memory.h utils/utils/tty.h utils/utils/path.h \
 utils/utils/status.h utils/utils/object.h utils/utils/time.h utils/utils/align.h
+if USE_WINDOWS
+  nobase_strongswan_include_HEADERS += \
+    utils/windows_helper.h \
+    networking/windows_tun.h
+if USE_WINTUN
+ nobase_strongswan_include_HEADERS += \
+   networking/wintun_support.h
+endif
+else
+ nobase_strongswan_include_HEADERS += \
+    networking/tun_device.h
+endif
 endif
 
 library.lo :	$(top_builddir)/config.status
@@ -146,19 +172,14 @@
 AM_YFLAGS = -v -d
 
 if USE_WINDOWS
-  libstrongswan_la_LIBADD += -lws2_32 -lpsapi
-  libstrongswan_la_SOURCES += \
-    threading/windows/thread.c \
-    threading/windows/thread_value.c \
-    threading/windows/mutex.c \
-    threading/windows/rwlock.c \
-    threading/windows/spinlock.c \
-    threading/windows/semaphore.c \
-    utils/compat/windows.c
+  libstrongswan_la_LIBADD += -lws2_32 -lpsapi -lcfgmgr32 -lsetupapi
 else
   libstrongswan_la_LIBADD += $(PTHREADLIB)
 endif
 
+if USE_WINTUN
+    libstrongswan_la_LIBADD += -lwinpthread
+endif
 if USE_DBGHELP
   libstrongswan_la_LIBADD += -ldbghelp
   AM_CPPFLAGS += -DHAVE_DBGHELP
diff -ruN strongswan-5.8.4/src/libstrongswan/networking/streams/stream_manager.c strongswancont-5.8.4-svc/src/libstrongswan/networking/streams/stream_manager.c
--- strongswan-5.8.4/src/libstrongswan/networking/streams/stream_manager.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/networking/streams/stream_manager.c	2022-07-08 11:28:38.154772000 +0300
@@ -17,10 +17,9 @@
 
 #include "stream_tcp.h"
 #include "stream_service_tcp.h"
-#ifndef WIN32
-# include "stream_unix.h"
-# include "stream_service_unix.h"
-#endif
+#include "stream_unix.h"
+#include "stream_service_unix.h"
+
 #ifdef USE_SYSTEMD
 # include "stream_service_systemd.h"
 #endif
@@ -205,10 +204,8 @@
 {
 	remove_stream(this, stream_create_tcp);
 	remove_service(this, stream_service_create_tcp);
-#ifndef WIN32
 	remove_stream(this, stream_create_unix);
 	remove_service(this, stream_service_create_unix);
-#endif
 #ifdef USE_SYSTEMD
 	remove_service(this, stream_service_create_systemd);
 #endif
@@ -243,10 +240,8 @@
 
 	add_stream(this, "tcp://", stream_create_tcp);
 	add_service(this, "tcp://", stream_service_create_tcp);
-#ifndef WIN32
 	add_stream(this, "unix://", stream_create_unix);
 	add_service(this, "unix://", stream_service_create_unix);
-#endif
 #ifdef USE_SYSTEMD
 	add_service(this, "systemd://", stream_service_create_systemd);
 #endif
